import os , sys , tempfile , subprocess , ntpath


def _createFileWith(instruction) :
    (fd , filename) = tempfile.mkstemp(suffix = '.c' , prefix = 'f4docker' , dir = '.')
    with os.fdopen(fd , 'w') as fileObj :
        fileObj.write(instruction)
    return ntpath.basename(filename)

# add compilation option e.g -lm  -fopenmp
class Docker() :
    def __init__(self , dockerCmd = 'docker ' ,
                 mountDir = '/home/salmane/mount/',
                 mountPoint = '/Doc ' , compCmd = 'gcc ' ,
                 dockerImg = 'with-gcc ') :
        
        self.dockerCmd = dockerCmd
        self.mountDir = mountDir
        self.mountPoint = mountPoint
        self.compCmd = compCmd
        self.dockerImg = dockerImg
        self._cmdPostFix = self.dockerCmd + ' run ' + ' -t -v ' + self.mountDir + ':' \
                         + self.mountPoint + ' -w ' + \
                         self.mountPoint + self.dockerImg + ' '
        
    def compString(self) :
        return  self.execString() + self.compCmd
    def execString(self) :
        return self._cmdPostFix

# exclusive cal file
# separate compiling , assembling and linking
def _compileHelper(docker , srcName) :
    execName = srcName + '.out'
    cmdOpt = docker.compString() + srcName + ' -o ' + execName
    #print 'executing : %s ' %cmdOpt
    #create temp file for output in /tmp --> tempfile.NamedTempFile or FIFO
    out = subprocess.Popen(cmdOpt , shell = True , stdout=subprocess.PIPE)
    #subprocess.Popen(cmdOpt , shell = True , stdout=subprocess.PIPE)
    result = out.stdout.read()
    return (result or 'success', execName)


def doCompile(docker , instruction = None , srcName = None) :
    if instruction :
        fileName = _createFileWith(instruction)
        #print 'in compile fileObj : ' + ' Name: ' + fileName + '\n'
        #print 'exist : ' + str(os.path.exists(fileName))
        return _compileHelper(docker , fileName)
    elif srcName :
        return _compileHelper(docker , srcName)
    else :
        print 'Give a parameter'
        sys.exit(-1)
        
def doExecute(docker , srcName) :
    cmdOpt = docker.execString() + './' + srcName
    out = subprocess.Popen(cmdOpt , shell = True , stdout = subprocess.PIPE)
    out.wait()
    #remove src and exec file if exist
    if os.path.exists('./' + srcName) :
        os.remove('./' + srcName)
        
    if os.path.exists(('./' + srcName)[:-4]) :
        os.remove(('./' + srcName)[:-4])
    return out.stdout.read()
        
 
        

if __name__  == "__main__" :
    docker = Docker()
    instructions = """ #include <stdio.h>
    int main(int argc , char* argv[])
    {
      printf("Hello World from Docker");
      return 0;
    }
    """
    (result , execName) = doCompile(docker , instructions) #srcName = 'hello.c'
    if result != 'success' :
        print 'Error while compiling --->\n %s\n' %result
    else:
        execResult = doExecute(docker , execName)
        print execResult
        
        
