from pysimplesoap.server import SoapDispatcher, SOAPHandler
from BaseHTTPServer import HTTPServer
import dockerHandler as DH

hocker = DH.Docker()

def comp(srcString) :
    """ Compile the C source string in paramater and returns the compilation log and executable name """
    (result , execName) = DH.doCompile(hocker , srcString)
    return {'compilationMsg' : result , 'executableName' : execName}

def execute(filename) :
    """ Execute a previously compiled file with name in parameter and returns the result """
    result = DH.doExecute(hocker , filename)
    return result 


dockerDispatcher = SoapDispatcher('dockerDispatcher' ,
                                  location = 'http://localhost:8009/' ,
                                  action = 'http://localhost:8009/' ,
                                  trace = True,
                                  ns = True
                                  )
# check pysimplesoap for args and returs passing (server)
dockerDispatcher.register_function('Compile' , comp ,
                                   returns = {'compilationMsg' : str , 'executableName' : str },
                                   args = {'srcString' : str})

dockerDispatcher.register_function('Execute' , execute,
                                    returns= {'executionResult' : str} ,
                                    args = {'filename' : str})



print dockerDispatcher.list_methods()
print "Starting server..."
httpd = HTTPServer(("", 8009), SOAPHandler)
httpd.dispatcher = dockerDispatcher
httpd.serve_forever()

