from SimpleXMLRPCServer import SimpleXMLRPCServer
from SimpleXMLRPCServer import SimpleXMLRPCRequestHandler
from dockerHandler import *

hocker = Docker()
def comp(srcString) :
   """ Compile the C source string in paramater and returns the compilation log and executable name """
   (result , execName) = doCompile(hocker , srcString)
   return {'compilationMsg' : result , 'executableName' : execName}

def execute(filename) :
    """ Execute a previously compiled file with name in parameter and returns the result """
    result = doExecute(hocker , filename)
    return result 
    

class RequestHandler(SimpleXMLRPCRequestHandler) :
    rpc_paths = ('/RPC2',)
    def _dispatch(self, method, params):
        try: 
            return self.server.funcs[method](*params)
        except:
            import traceback
            traceback.print_exc()
            raise
    

LISTENING_PORT = 8008

server = SimpleXMLRPCServer(('localhost' , LISTENING_PORT),
                             requestHandler = RequestHandler)

server.register_multicall_functions()
server.register_introspection_functions()
print "Listening on port %d..." %LISTENING_PORT
server.register_function(comp , 'Compile')
server.register_function(execute , 'Execute')
server.serve_forever()
